Index: lib/README
===================================================================
RCS file: lib/README
diff -N lib/README
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ lib/README	26 Jun 2007 14:26:56 -0000
@@ -0,0 +1,4 @@
+This subdirectory contains some useful shared code which is used
+in other parts of the library and in standalone programs.
+
+		- Richard W.M. Jones, 2007-06-26
Index: lib/buf.c
===================================================================
RCS file: lib/buf.c
diff -N lib/buf.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ lib/buf.c	26 Jun 2007 14:26:56 -0000
@@ -0,0 +1,210 @@
+/*
+ * buf.c: buffers for qemud
+ *
+ * Copyright (C) 2005 Red Hat, Inc.
+ *
+ * See COPYING.LIB for the License of this software
+ *
+ * Daniel Veillard <veillard@redhat.com>
+ */
+
+#include "libvirt/libvirt.h"
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <stdarg.h>
+#include "buf.h"
+
+/**
+ * bufferGrow:
+ * @buf:  the buffer
+ * @len:  the minimum free size to allocate on top of existing used space
+ *
+ * Grow the available space of a buffer to at least @len bytes.
+ *
+ * Returns the new available space or -1 in case of error
+ */
+static int
+bufferGrow(bufferPtr buf, unsigned int len)
+{
+    int size;
+    char *newbuf;
+
+    if (buf == NULL)
+        return (-1);
+    if (len + buf->use < buf->size)
+        return (0);
+
+    size = buf->use + len + 1000;
+
+    newbuf = (char *) realloc(buf->content, size);
+    if (newbuf == NULL) return -1;
+    buf->content = newbuf;
+    buf->size = size;
+    return (buf->size - buf->use);
+}
+
+/**
+ * bufferAdd:
+ * @buf:  the buffer to dump
+ * @str:  the string
+ * @len:  the number of bytes to add
+ *
+ * Add a string range to an XML buffer. if len == -1, the length of
+ * str is recomputed to the full string.
+ *
+ * Returns 0 successful, -1 in case of internal or API error.
+ */
+int
+bufferAdd(bufferPtr buf, const char *str, int len)
+{
+    unsigned int needSize;
+
+    if ((str == NULL) || (buf == NULL)) {
+        return -1;
+    }
+    if (len == 0)
+        return 0;
+
+    if (len < 0)
+        len = strlen(str);
+
+    needSize = buf->use + len + 2;
+    if (needSize > buf->size) {
+        if (!bufferGrow(buf, needSize - buf->use)) {
+            return (-1);
+        }
+    }
+    /* XXX: memmove() is 2x slower than memcpy(), do we really need it? */
+    memmove(&buf->content[buf->use], str, len);
+    buf->use += len;
+    buf->content[buf->use] = 0;
+    return (0);
+}
+
+bufferPtr
+bufferNew(unsigned int size)
+{
+    bufferPtr buf;
+
+    if (!(buf = malloc(sizeof(*buf)))) return NULL;
+    if (size && (buf->content = malloc(size))==NULL) {
+        free(buf);
+        return NULL;
+    }
+    buf->size = size;
+    buf->use = 0;
+
+    return buf;
+}
+
+void
+bufferFree(bufferPtr buf)
+{
+    if (buf) {
+        if (buf->content)
+            free(buf->content);
+        free(buf);
+    }
+}
+
+/**
+ * bufferContentAndFree:
+ * @buf: Buffer
+ *
+ * Return the content from the buffer and free (only) the buffer structure.
+ */
+char *
+bufferContentAndFree (bufferPtr buf)
+{
+    char *content = buf->content;
+
+    free (buf);
+    return content;
+}
+
+/**
+ * bufferVSprintf:
+ * @buf:  the buffer to dump
+ * @format:  the format
+ * @argptr:  the variable list of arguments
+ *
+ * Do a formatted print to an XML buffer.
+ *
+ * Returns 0 successful, -1 in case of internal or API error.
+ */
+int
+bufferVSprintf(bufferPtr buf, const char *format, ...)
+{
+    int size, count;
+    va_list locarg, argptr;
+
+    if ((format == NULL) || (buf == NULL)) {
+        return (-1);
+    }
+    size = buf->size - buf->use - 1;
+    va_start(argptr, format);
+    va_copy(locarg, argptr);
+    while (((count = vsnprintf(&buf->content[buf->use], size, format,
+                               locarg)) < 0) || (count >= size - 1)) {
+        buf->content[buf->use] = 0;
+        va_end(locarg);
+        if (bufferGrow(buf, 1000) < 0) {
+            return (-1);
+        }
+        size = buf->size - buf->use - 1;
+        va_copy(locarg, argptr);
+    }
+    va_end(locarg);
+    buf->use += count;
+    buf->content[buf->use] = 0;
+    return (0);
+}
+
+/**
+ * bufferStrcat:
+ * @buf:  the buffer to dump
+ * @argptr:  the variable list of strings, the last argument must be NULL
+ *
+ * Concatenate strings to an XML buffer.
+ *
+ * Returns 0 successful, -1 in case of internal or API error.
+ */
+int
+bufferStrcat(bufferPtr buf, ...)
+{
+    va_list ap;
+    char *str;
+
+    va_start(ap, buf);
+
+    while ((str = va_arg(ap, char *)) != NULL) {
+        unsigned int len = strlen(str);
+        unsigned int needSize = buf->use + len + 2;
+
+        if (needSize > buf->size) {
+            if (!bufferGrow(buf, needSize - buf->use))
+                return -1;
+        }
+        memcpy(&buf->content[buf->use], str, len);
+        buf->use += len;
+        buf->content[buf->use] = 0;
+    }
+    va_end(ap);
+    return 0;
+}
+
+/*
+ * vim: set tabstop=4:
+ * vim: set shiftwidth=4:
+ * vim: set expandtab:
+ */
+/*
+ * Local variables:
+ *  indent-tabs-mode: nil
+ *  c-indent-level: 4
+ *  c-basic-offset: 4
+ *  tab-width: 4
+ * End:
+ */
Index: lib/buf.h
===================================================================
RCS file: lib/buf.h
diff -N lib/buf.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ lib/buf.h	26 Jun 2007 14:26:56 -0000
@@ -0,0 +1,37 @@
+/*
+ * buf.h: buffers for qemud
+ *
+ * Copyright (C) 2005 Red Hat, Inc.
+ *
+ * See COPYING.LIB for the License of this software
+ *
+ * Daniel Veillard <veillard@redhat.com>
+ */
+
+#ifndef __QEMUD_BUF_H__
+#define __QEMUD_BUF_H__
+
+#include "internal.h"
+
+/**
+ * buffer:
+ *
+ * A buffer structure.
+ */
+typedef struct _buffer buffer;
+typedef buffer *bufferPtr;
+struct _buffer {
+    char *content;          /* The buffer content UTF8 */
+    unsigned int use;       /* The buffer size used */
+    unsigned int size;      /* The buffer size */
+};
+
+bufferPtr bufferNew(unsigned int size);
+void bufferFree(bufferPtr buf);
+char *bufferContentAndFree(bufferPtr buf);
+int bufferAdd(bufferPtr buf, const char *str, int len);
+int bufferVSprintf(bufferPtr buf, const char *format, ...)
+  ATTRIBUTE_FORMAT(printf, 2, 3);
+int bufferStrcat(bufferPtr buf, ...);
+
+#endif                          /* __QEMUD_BUF_H__ */
Index: proxy/Makefile.am
===================================================================
RCS file: /data/cvs/libvirt/proxy/Makefile.am,v
retrieving revision 1.10
diff -u -p -r1.10 Makefile.am
--- proxy/Makefile.am	29 May 2007 14:44:15 -0000	1.10
+++ proxy/Makefile.am	26 Jun 2007 14:26:56 -0000
@@ -1,7 +1,11 @@
 ## Process this file with automake to produce Makefile.in
 
-INCLUDES = -I$(top_builddir)/include -I@top_srcdir@/include \
-           -I@top_srcdir@/proxy -I@top_srcdir@/src @LIBXML_CFLAGS@ \
+INCLUDES = -I$(top_builddir)/include \
+	   -I@top_srcdir@/include \
+	   -I@top_srcdir@/lib \
+           -I@top_srcdir@/proxy \
+	   -I@top_srcdir@/src \
+	   @LIBXML_CFLAGS@ \
 	   -DPROXY  -DLOCALEBASEDIR=\""$(datadir)/locale"\" \
            -DGETTEXT_PACKAGE=\"$(PACKAGE)\" $(WARN_CFLAGS) $(LIBVIRT_FEATURES)
 
@@ -10,7 +14,8 @@ libexec_PROGRAMS = libvirt_proxy
 libvirt_proxy_SOURCES = libvirt_proxy.c @top_srcdir@/src/xend_internal.c \
 	    @top_srcdir@/src/xen_internal.c @top_srcdir@/src/virterror.c \
 	    @top_srcdir@/src/sexpr.c @top_srcdir@/src/xml.c \
-            @top_srcdir@/src/xs_internal.c
+            @top_srcdir@/src/xs_internal.c \
+	    @top_srcdir@/lib/buf.c @top_srcdir@/lib/buf.h
 libvirt_proxy_LDFLAGS = $(WARN_CFLAGS)
 libvirt_proxy_DEPENDENCIES =
 libvirt_proxy_LDADD =
Index: qemud/Makefile.am
===================================================================
RCS file: /data/cvs/libvirt/qemud/Makefile.am,v
retrieving revision 1.21
diff -u -p -r1.21 Makefile.am
--- qemud/Makefile.am	11 Jun 2007 13:24:45 -0000	1.21
+++ qemud/Makefile.am	26 Jun 2007 14:26:56 -0000
@@ -13,13 +13,16 @@ libvirt_qemud_SOURCES = \
                 bridge.c bridge.h \
                 iptables.c iptables.h \
                 uuid.c uuid.h \
-		buf.c buf.h \
+		../lib/buf.c ../lib/buf.h \
 		protocol.h protocol.c \
 		remote_protocol.h remote_protocol.c \
 		remote.c
 #-D_XOPEN_SOURCE=600 -D_XOPEN_SOURCE_EXTENDED=1 -D_POSIX_C_SOURCE=199506L
 libvirt_qemud_CFLAGS = \
-        -I$(top_srcdir)/include -I$(top_builddir)/include $(LIBXML_CFLAGS) \
+        -I$(top_srcdir)/include \
+	-I$(top_builddir)/include \
+	-I$(top_srcdir)/lib \
+	$(LIBXML_CFLAGS) \
         $(WARN_CFLAGS) -DLOCAL_STATE_DIR="\"$(localstatedir)\"" \
         -DSYSCONF_DIR="\"$(sysconfdir)\"" \
 	-DQEMUD_PID_FILE="\"$(QEMUD_PID_FILE)\"" \
Index: src/Makefile.am
===================================================================
RCS file: /data/cvs/libvirt/src/Makefile.am,v
retrieving revision 1.40
diff -u -p -r1.40 Makefile.am
--- src/Makefile.am	15 Jun 2007 01:21:18 -0000	1.40
+++ src/Makefile.am	26 Jun 2007 14:26:56 -0000
@@ -2,6 +2,7 @@
 
 INCLUDES = -I$(top_builddir)/include \
 	   -I@top_srcdir@/include \
+	   -I@top_srcdir@/lib \
 	   -I@top_srcdir@/qemud \
 	   @LIBXML_CFLAGS@ \
 	   -DBINDIR=\""$(libexecdir)"\" \
@@ -27,6 +28,7 @@ libvirt_la_CFLAGS = $(COVERAGE_CFLAGS)
 
 CLIENT_SOURCES =						\
 		libvirt.c internal.h				\
+		../lib/buf.c ../lib/buf.h			\
 		hash.c hash.h					\
 		test.c test.h                                   \
 		xml.c xml.h					\
Index: src/conf.c
===================================================================
RCS file: /data/cvs/libvirt/src/conf.c,v
retrieving revision 1.9
diff -u -p -r1.9 conf.c
--- src/conf.c	22 Mar 2007 18:30:57 -0000	1.9
+++ src/conf.c	26 Jun 2007 14:26:57 -0000
@@ -18,6 +18,7 @@
 #include <fcntl.h>
 
 #include "internal.h"
+#include "buf.h"
 #include "xml.h"
 #include "conf.h"
 
@@ -237,7 +238,7 @@ virConfAddEntry(virConfPtr conf, char *n
  * Returns 0 in case of success, -1 in case of error.
  */
 static int
-virConfSaveValue(virBufferPtr buf, virConfValuePtr val)
+virConfSaveValue(bufferPtr buf, virConfValuePtr val)
 {
     if (val == NULL)
         return(-1);
@@ -245,34 +246,34 @@ virConfSaveValue(virBufferPtr buf, virCo
         case VIR_CONF_NONE:
 	    return(-1);
 	case VIR_CONF_LONG:
-	    virBufferVSprintf(buf, "%ld", val->l);
+	    bufferVSprintf(buf, "%ld", val->l);
 	    break;
 	case VIR_CONF_STRING:
 	    if (strchr(val->str, '\n') != NULL) {
-		virBufferVSprintf(buf, "\"\"\"%s\"\"\"", val->str);
+		bufferVSprintf(buf, "\"\"\"%s\"\"\"", val->str);
 	    } else if (strchr(val->str, '"') == NULL) {
-		virBufferVSprintf(buf, "\"%s\"", val->str);
+		bufferVSprintf(buf, "\"%s\"", val->str);
 	    } else if (strchr(val->str, '\'') == NULL) {
-		virBufferVSprintf(buf, "'%s'", val->str);
+		bufferVSprintf(buf, "'%s'", val->str);
 	    } else {
-		virBufferVSprintf(buf, "\"\"\"%s\"\"\"", val->str);
+		bufferVSprintf(buf, "\"\"\"%s\"\"\"", val->str);
 	    }
 	    break;
 	case VIR_CONF_LIST: {
 	    virConfValuePtr cur;
 
 	    cur = val->list;
-	    virBufferAdd(buf, "[ ", 2);
+	    bufferAdd(buf, "[ ", 2);
 	    if (cur != NULL) {
 	        virConfSaveValue(buf, cur);
 		cur = cur->next;
 		while (cur != NULL) {
-		    virBufferAdd(buf, ", ", 2);
+		    bufferAdd(buf, ", ", 2);
 		    virConfSaveValue(buf, cur);
 		    cur = cur->next;
 		}
 	    }
-	    virBufferAdd(buf, " ]", 2);
+	    bufferAdd(buf, " ]", 2);
 	    break;
 	}
 	default:
@@ -291,21 +292,21 @@ virConfSaveValue(virBufferPtr buf, virCo
  * Returns 0 in case of success, -1 in case of error.
  */
 static int
-virConfSaveEntry(virBufferPtr buf, virConfEntryPtr cur)
+virConfSaveEntry(bufferPtr buf, virConfEntryPtr cur)
 {
     if (cur->name != NULL) {
-        virBufferAdd(buf, cur->name, -1);
-	virBufferAdd(buf, " = ", 3);
+        bufferAdd(buf, cur->name, -1);
+	bufferAdd(buf, " = ", 3);
 	virConfSaveValue(buf, cur->value);
 	if (cur->comment != NULL) {
-	    virBufferAdd(buf, " #", 2);
-	    virBufferAdd(buf, cur->comment, -1);
+	    bufferAdd(buf, " #", 2);
+	    bufferAdd(buf, cur->comment, -1);
 	}
     } else if (cur->comment != NULL) {
-	virBufferAdd(buf, "#", 1);
-	virBufferAdd(buf, cur->comment, -1);
+	bufferAdd(buf, "#", 1);
+	bufferAdd(buf, cur->comment, -1);
     }
-    virBufferAdd(buf, "\n", 1);
+    bufferAdd(buf, "\n", 1);
     return(0);
 }
 
@@ -874,7 +875,7 @@ __virConfSetValue (virConfPtr conf,
 int
 __virConfWriteFile(const char *filename, virConfPtr conf)
 {
-    virBufferPtr buf;
+    bufferPtr buf;
     virConfEntryPtr cur;
     int ret;
     int fd;
@@ -882,9 +883,11 @@ __virConfWriteFile(const char *filename,
     if (conf == NULL)
         return(-1);
 
-    buf = virBufferNew(500);
-    if (buf == NULL)
+    buf = bufferNew(500);
+    if (buf == NULL) {
+        virConfError(NULL, VIR_ERR_NO_MEMORY, _("failed to allocate buffer"), 0);
         return(-1);
+    }
 
     cur = conf->entries;
     while (cur != NULL) {
@@ -907,7 +910,7 @@ __virConfWriteFile(const char *filename,
 	goto error;
     }
 error:
-    virBufferFree(buf);
+    bufferFree(buf);
     return(ret);
 }
 
@@ -927,16 +930,18 @@ error:
 int
 __virConfWriteMem(char *memory, int *len, virConfPtr conf)
 {
-    virBufferPtr buf;
+    bufferPtr buf;
     virConfEntryPtr cur;
     int ret;
 
     if ((memory == NULL) || (len == NULL) || (*len <= 0) || (conf == NULL))
         return(-1);
 
-    buf = virBufferNew(500);
-    if (buf == NULL)
+    buf = bufferNew(500);
+    if (buf == NULL) {
+        virConfError(NULL, VIR_ERR_NO_MEMORY, _("failed to allocate buffer"), 0);
         return(-1);
+    }
 
     cur = conf->entries;
     while (cur != NULL) {
@@ -953,7 +958,7 @@ __virConfWriteMem(char *memory, int *len
     ret = buf->use;
     *len = buf->use;
 error:
-    virBufferFree(buf);
+    bufferFree(buf);
     return(ret);
 }
 
Index: src/sexpr.c
===================================================================
RCS file: /data/cvs/libvirt/src/sexpr.c,v
retrieving revision 1.6
diff -u -p -r1.6 sexpr.c
--- src/sexpr.c	14 Feb 2007 15:40:54 -0000	1.6
+++ src/sexpr.c	26 Jun 2007 14:26:57 -0000
@@ -10,7 +10,7 @@
  *  archive for more details.
  */
 
-#define _GNU_SOURCE
+#define _GNU_SOURCE /* for strndup */
 
 #include "sexpr.h"
 #include "internal.h"
Index: src/test.c
===================================================================
RCS file: /data/cvs/libvirt/src/test.c,v
retrieving revision 1.36
diff -u -p -r1.36 test.c
--- src/test.c	26 Jun 2007 11:42:46 -0000	1.36
+++ src/test.c	26 Jun 2007 14:26:58 -0000
@@ -39,6 +39,7 @@
 #include "internal.h"
 #include "test.h"
 #include "xml.h"
+#include "buf.h"
 
 int testOpen(virConnectPtr conn,
              const char *name,
@@ -1365,7 +1366,7 @@ int testSetVcpus(virDomainPtr domain,
 
 char * testDomainDumpXML(virDomainPtr domain, int flags ATTRIBUTE_UNUSED)
 {
-    virBufferPtr buf;
+    bufferPtr buf;
     char *xml;
     unsigned char *uuid;
     testCon *con;
@@ -1382,27 +1383,28 @@ char * testDomainDumpXML(virDomainPtr do
     priv = (testPrivatePtr) domain->conn->privateData;
     con = &node->connections[priv->handle];
 
-    if (!(buf = virBufferNew(4000))) {
+    if (!(buf = bufferNew(4000))) {
+        testError(domain->conn, domain, VIR_ERR_NO_MEMORY, __FUNCTION__);
         return (NULL);
     }
 
-    virBufferVSprintf(buf, "<domain type='test' id='%d'>\n", domain->id);
-    virBufferVSprintf(buf, "  <name>%s</name>\n", domain->name);
+    bufferVSprintf(buf, "<domain type='test' id='%d'>\n", domain->id);
+    bufferVSprintf(buf, "  <name>%s</name>\n", domain->name);
     uuid = domain->uuid;
-    virBufferVSprintf(buf,
+    bufferVSprintf(buf,
                       "  <uuid>%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x</uuid>\n",
                       uuid[0], uuid[1], uuid[2], uuid[3],
                       uuid[4], uuid[5], uuid[6], uuid[7],
                       uuid[8], uuid[9], uuid[10], uuid[11],
                       uuid[12], uuid[13], uuid[14], uuid[15]);
 
-    virBufferVSprintf(buf, "  <memory>%lu</memory>\n", con->domains[domidx].info.maxMem);
-    virBufferVSprintf(buf, "  <vcpu>%d</vcpu>\n", con->domains[domidx].info.nrVirtCpu);
-    virBufferVSprintf(buf, "  <on_reboot>%s</on_reboot>\n", testRestartFlagToString(con->domains[domidx].onReboot));
-    virBufferVSprintf(buf, "  <on_poweroff>%s</on_poweroff>\n", testRestartFlagToString(con->domains[domidx].onPoweroff));
-    virBufferVSprintf(buf, "  <on_crash>%s</on_crash>\n", testRestartFlagToString(con->domains[domidx].onCrash));
+    bufferVSprintf(buf, "  <memory>%lu</memory>\n", con->domains[domidx].info.maxMem);
+    bufferVSprintf(buf, "  <vcpu>%d</vcpu>\n", con->domains[domidx].info.nrVirtCpu);
+    bufferVSprintf(buf, "  <on_reboot>%s</on_reboot>\n", testRestartFlagToString(con->domains[domidx].onReboot));
+    bufferVSprintf(buf, "  <on_poweroff>%s</on_poweroff>\n", testRestartFlagToString(con->domains[domidx].onPoweroff));
+    bufferVSprintf(buf, "  <on_crash>%s</on_crash>\n", testRestartFlagToString(con->domains[domidx].onCrash));
 
-    virBufferAdd(buf, "</domain>\n", -1);
+    bufferAdd(buf, "</domain>\n", -1);
 
     xml = buf->content;
     free(buf);
Index: src/virsh.c
===================================================================
RCS file: /data/cvs/libvirt/src/virsh.c,v
retrieving revision 1.89
diff -u -p -r1.89 virsh.c
--- src/virsh.c	26 Jun 2007 11:42:46 -0000	1.89
+++ src/virsh.c	26 Jun 2007 14:27:01 -0000
@@ -13,8 +13,6 @@
  * $Id: virsh.c,v 1.89 2007/06/26 11:42:46 rjones Exp $
  */
 
-#define _GNU_SOURCE             /* isblank() */
-
 #include "libvirt/libvirt.h"
 #include "libvirt/virterror.h"
 #include <stdio.h>
@@ -3789,7 +3787,7 @@ vshCommandGetToken(vshControl * ctl, cha
 
     *end = NULL;
 
-    while (p && *p && isblank((unsigned char) *p))
+    while (p && *p && (*p == ' ' || *p == '\t'))
         p++;
 
     if (p == NULL || *p == '\0')
@@ -3800,7 +3798,7 @@ vshCommandGetToken(vshControl * ctl, cha
     }
     while (*p) {
         /* end of token is blank space or ';' */
-        if ((quote == FALSE && isblank((unsigned char) *p)) || *p == ';')
+        if ((quote == FALSE && (*p == ' ' || *p == '\t')) || *p == ';')
             break;
 
         /* end of option name could be '=' */
Index: src/xen_internal.c
===================================================================
RCS file: /data/cvs/libvirt/src/xen_internal.c,v
retrieving revision 1.81
diff -u -p -r1.81 xen_internal.c
--- src/xen_internal.c	26 Jun 2007 11:42:46 -0000	1.81
+++ src/xen_internal.c	26 Jun 2007 14:27:02 -0000
@@ -35,6 +35,7 @@
 /* required for shutdown flags */
 #include <xen/sched.h>
 
+#include "buf.h"
 #include "xml.h"
 
 /* #define DEBUG */
@@ -2017,7 +2018,7 @@ xenHypervisorMakeCapabilitiesXML(virConn
     } guest_archs[32];
     int nr_guest_archs = 0;
 
-    virBufferPtr xml;
+    bufferPtr xml;
     char *xml_str;
 
     memset(guest_archs, 0, sizeof(guest_archs));
@@ -2137,9 +2138,12 @@ xenHypervisorMakeCapabilitiesXML(virConn
     }
 
     /* Construct the final XML. */
-    xml = virBufferNew (1024);
-    if (!xml) return NULL;
-    r = virBufferVSprintf (xml,
+    xml = bufferNew (1024);
+    if (!xml) {
+        virXenError(VIR_ERR_NO_MEMORY, __FUNCTION__, 0);
+        return NULL;
+    }
+    r = bufferVSprintf (xml,
                            "\
 <capabilities>\n\
   <host>\n\
@@ -2150,18 +2154,18 @@ xenHypervisorMakeCapabilitiesXML(virConn
     if (r == -1) goto vir_buffer_failed;
 
     if (strcmp (hvm_type, "") != 0) {
-        r = virBufferVSprintf (xml,
+        r = bufferVSprintf (xml,
                                "\
         <%s/>\n",
                                hvm_type);
         if (r == -1) goto vir_buffer_failed;
     }
     if (host_pae) {
-        r = virBufferAdd (xml, "\
+        r = bufferAdd (xml, "\
         <pae/>\n", -1);
         if (r == -1) goto vir_buffer_failed;
     }
-    r = virBufferAdd (xml,
+    r = bufferAdd (xml,
                       "\
       </features>\n\
     </cpu>\n\
@@ -2169,7 +2173,7 @@ xenHypervisorMakeCapabilitiesXML(virConn
     if (r == -1) goto vir_buffer_failed;
 
     for (i = 0; i < nr_guest_archs; ++i) {
-        r = virBufferVSprintf (xml,
+        r = bufferVSprintf (xml,
                                "\
 \n\
   <guest>\n\
@@ -2182,7 +2186,7 @@ xenHypervisorMakeCapabilitiesXML(virConn
                                guest_archs[i].bits);
         if (r == -1) goto vir_buffer_failed;
         if (guest_archs[i].hvm) {
-            r = virBufferVSprintf (xml,
+            r = bufferVSprintf (xml,
                               "\
       <emulator>/usr/lib%s/xen/bin/qemu-dm</emulator>\n\
       <machine>pc</machine>\n\
@@ -2191,50 +2195,48 @@ xenHypervisorMakeCapabilitiesXML(virConn
                                    guest_archs[i].bits == 64 ? "64" : "");
             if (r == -1) goto vir_buffer_failed;
         }
-        r = virBufferAdd (xml,
+        r = bufferAdd (xml,
                           "\
     </arch>\n\
     <features>\n", -1);
         if (r == -1) goto vir_buffer_failed;
         if (guest_archs[i].pae) {
-            r = virBufferAdd (xml,
+            r = bufferAdd (xml,
                               "\
       <pae/>\n", -1);
             if (r == -1) goto vir_buffer_failed;
         }
         if (guest_archs[i].nonpae) {
-            r = virBufferAdd (xml,
+            r = bufferAdd (xml,
                               "\
       <nonpae/>\n", -1);
             if (r == -1) goto vir_buffer_failed;
         }
         if (guest_archs[i].ia64_be) {
-            r = virBufferAdd (xml,
+            r = bufferAdd (xml,
                               "\
       <ia64_be/>\n", -1);
             if (r == -1) goto vir_buffer_failed;
         }
-        r = virBufferAdd (xml,
+        r = bufferAdd (xml,
                           "\
     </features>\n\
   </guest>\n", -1);
         if (r == -1) goto vir_buffer_failed;
     }
-    r = virBufferAdd (xml,
+    r = bufferAdd (xml,
                       "\
 </capabilities>\n", -1);
     if (r == -1) goto vir_buffer_failed;
     xml_str = strdup (xml->content);
-    if (!xml_str) {
-        virXenError(VIR_ERR_NO_MEMORY, "strdup", 0);
-        goto vir_buffer_failed;
-    }
-    virBufferFree (xml);
+    if (!xml_str) goto vir_buffer_failed;
+    bufferFree (xml);
 
     return xml_str;
 
  vir_buffer_failed:
-    virBufferFree (xml);
+    virXenError(VIR_ERR_NO_MEMORY, __FUNCTION__, 0);
+    bufferFree (xml);
     return NULL;
 }
 
